"use strict";
cc._RF.push(module, '87acaJW44FFCpXo8TrKCc/X', 'draw-line');
// Script/draw-line.ts

"use strict";
// Learn TypeScript:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/typescript.html
//  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/typescript.html
// Learn Attribute:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/reference/attributes.html
//  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/life-cycle-callbacks.html
//  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/life-cycle-callbacks.html
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var NewClass = /** @class */ (function (_super) {
    __extends(NewClass, _super);
    function NewClass() {
        // LIFE-CYCLE CALLBACKS:
        var _this = _super !== null && _super.apply(this, arguments) || this;
        // onLoad () {}
        _this.btnClear = null;
        _this.touches = [];
        _this.graphics = null;
        return _this;
    }
    NewClass.prototype.start = function () {
        var canvas = cc.find('Canvas');
        canvas.on(cc.Node.EventType.MOUSE_DOWN, this.onTouchStart, this);
        canvas.on(cc.Node.EventType.MOUSE_MOVE, this.onTouchMove, this);
        canvas.on(cc.Node.EventType.MOUSE_UP, this.onTouchEnd, this);
        this.graphics = this.getComponent(cc.Graphics);
        // this.graphics.moveTo(0, 0);
        // this.graphics.lineTo(0.1, 0);
        // this.graphics.lineTo(-0.11, 0);
        // this.graphics.stroke();
        console.log(cc.sys.os);
    };
    NewClass.prototype.onEnable = function () {
        this.btnClear.on(cc.Node.EventType.TOUCH_END, this.onClear, this);
    };
    NewClass.prototype.onDisable = function () {
        this.btnClear.off(cc.Node.EventType.TOUCH_END, this.onClear, this);
    };
    NewClass.prototype.onTouchStart = function (event) {
        this.touches.length = 0;
        this.touches.push(event.getLocation());
        console.log("start draw");
    };
    NewClass.prototype.onTouchMove = function (event) {
        console.log("move draw");
        var touches = this.touches;
        touches.push(event.getLocation());
        var MIN_POINT_DISTANCE = 2;
        // this.graphics.clear();
        var worldPos = this.node.convertToWorldSpaceAR(cc.v2());
        this.graphics.moveTo(touches[0].x - worldPos.x, touches[0].y - worldPos.y);
        var lastIndex = 0;
        for (var i = 1, l = touches.length; i < l; i++) {
            if (touches[i].sub(touches[lastIndex]).mag() < MIN_POINT_DISTANCE) {
                continue;
            }
            lastIndex = i;
            this.graphics.lineTo(touches[i].x - worldPos.x, touches[i].y - worldPos.y);
        }
        this.graphics.stroke();
    };
    NewClass.prototype.onTouchEnd = function (event) {
        console.log("start end");
    };
    NewClass.prototype.onClear = function () {
        console.log("clear");
        this.graphics.clear();
    };
    __decorate([
        property(cc.Node)
    ], NewClass.prototype, "btnClear", void 0);
    NewClass = __decorate([
        ccclass
    ], NewClass);
    return NewClass;
}(cc.Component));
exports.default = NewClass;

cc._RF.pop();